<?php
/**
 * @version		$Id: grade_form.php,v 1.24 2012-07-26 18:38:26 juanca Exp $
 * @package		VPL. Grade form definition
 * @copyright	2012 Juan Carlos Rodríguez-del-Pino
 * @license		http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 * @author		Juan Carlos Rodríguez-del-Pino <jcrodriguez@dis.ulpgc.es>
 */

require_once dirname(__FILE__).'/../../../config.php';
require_once $CFG->libdir.'/formslib.php';
require_once $CFG->libdir.'/gradelib.php';
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/form.class.php';

class mod_vpl_grade_form extends vpl_form {
	protected $vpl;
	protected function get_scale_selection(){
		global $DB;
		$vplinstance = $this->vpl->get_instance();
		$scaleid = $vplinstance->grade;
		$options = array();
		$options[-1]= get_string('nograde');
		if ($scaleid > 0) {
			for($i = 0 ; $i <= $scaleid; $i++){
				$options[$i] = $i.' / '.$scaleid;
			}
		} elseif($scaleid < 0) {
			$scaleid = -$scaleid;
			if ($scale = $DB->get_record('scale', array('id' => $scaleid))) {
				$options = $options + make_menu_from_list($scale->scale);
			}
		}
		return $options;
	}
	
	function __construct($page,& $vpl){
		$this->vpl = & $vpl;
		parent::__construct($page);
	}
	function definition(){
		global $CFG;
		$id = required_param('id',PARAM_INT);
		$userid = optional_param('userid',null,PARAM_INT);
		$inpopup = optional_param('inpopup',0,PARAM_INT);
		$this->addHidden('id',$id);
		$this->addHidden('userid',$userid);
		$submissionid=optional_param('submissionid',0,PARAM_INT);
		if($submissionid>0){
			$this->addHidden('submissionid',$submissionid);
		}
		$this->addHidden('inpopup',$inpopup);
		//TODO Improve grade form (recalculate grade)
		//Show assesment criteria
		//Show others evaluation
		//Type value => introduce value
		//TODO locked grading
		if($this->vpl->get_instance()->grade !=0){
			$this->addHTML(s(get_string('grade').' '));
			if($this->vpl->get_instance()->grade>0){
				$this->addText('grade','',6);
			}
			else{
				$this->addSelect('grade',$this->get_scale_selection());
			}
			$this->addHTML(' &nbsp;');
		}
		$this->addSubmitButton('save',get_string('grade'));
		if($inpopup){
			$this->addSubmitButton('savenext',get_string('gradeandnext',VPL));
		}
		$this->addSubmitButton('removegrade',get_string('removegrade',VPL));
		if($this->vpl->get_instance()->evaluate){
			//Link to recalculate numeric grade from comments
			$url=vpl_mod_href('forms/evaluation.php','id',
			         $id,'userid',$userid,'grading',1,'inpopup',$inpopup);
			$html=' <a href="'.$url.'">'.s(get_string('evaluate',VPL)).'</a>';
			$this->addHTML($html);
		}
		//Numeric grade
		if($this->vpl->get_instance()->grade >0){
			//Link to recalculate numeric grade from comments
			$jscript='VPL.calculateGrade('.$this->vpl->get_instance()->grade.')';
			$html=' <a href="javascript:void(0);" onclick="'.$jscript.'">'.s(get_string('calculate',VPL)).'</a>';
			$this->addHTML($html);
		}
		//TODO user similarity
/*		$url=vpl_mod_href('similarity/user_similarity.php','id',$id,'userid',$userid);
		$html=link_to_popup_window($url,'similarity'.$id.'-'.$userid,get_string('similarity',VPL),800,900,null,null,true);
		$this->addHTML(' '.$html);*/
		$this->addHTML('<br />');
		if($this->vpl->get_instance()->grade !=0){
			$this->addHTML(s(get_string('comments',VPL)).'<br />');
			$this->addTextArea('comments','',8,70);
			$this->addHTML('<br />');
		}
		if(!empty($CFG->enableoutcomes)){
			$grading_info = grade_get_grades($this->vpl->get_course()->id, 'mod', 'vpl',
					$this->vpl->get_instance()->id, $userid);
			if (!empty($grading_info->outcomes)) {
				$this->addHTML('<table border="0">');
			 	foreach($grading_info->outcomes as $oid=>$outcome) {
			 		//TODO outcomes locked
			 		//if ($outcome->grades[$userid]->locked) {
			 		//	continue;
			 		//}
				    $this->addHTML('<tr><td align="right">');
			 		$options = make_grades_menu(-$outcome->scaleid);
			 		$options[0] = get_string('nooutcome', 'grades');
					$this->addHTML(s($outcome->name));
					$this->addHTML('</td><td>');
					$this->addSelect('outcome_grade_'.$oid,$options,$outcome->grades[$userid]->grade);
				    $this->addHTML('</td></tr>');
			 	}
			 	$this->addHTML('</table>');
			 }
		}
	}
	function display(){
		global $OUTPUT;
		echo $OUTPUT->box_start();
		parent::display();
		echo $OUTPUT->box_end();
	}
}

?>
